#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GoldenTurtleFishCFG.h"
std::auto_ptr<Fish_GoldenTurtleFishCFG> Fish_GoldenTurtleFishCFG::msSingleton(nullptr);

int Fish_GoldenTurtleFishCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GoldenTurtleFishCFGData* Fish_GoldenTurtleFishCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GoldenTurtleFishCFGData>& Fish_GoldenTurtleFishCFG::GetMapData()
{
	return mMapData;
}

void Fish_GoldenTurtleFishCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GoldenTurtleFishCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GoldenTurtleFishCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mFishId = element->IntAttribute("FishId");
		data.mMinimumScore = element->IntAttribute("MinimumScore");
		data.mMaximumScore = element->IntAttribute("MaximumScore");
		data.mTelephoneScore = element->IntAttribute("TelephoneScore");
		data.mweight = element->IntAttribute("weight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GoldenTurtleFishCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GoldenTurtleFishCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GoldenTurtleFishCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GoldenTurtleFishCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GoldenTurtleFishCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "FishId", data.mFishId);
		LuaCfgHelper::readInt(L, "MinimumScore", data.mMinimumScore);
		LuaCfgHelper::readInt(L, "MaximumScore", data.mMaximumScore);
		LuaCfgHelper::readInt(L, "TelephoneScore", data.mTelephoneScore);
		LuaCfgHelper::readInt(L, "weight", data.mweight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GoldenTurtleFishCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GoldenTurtleFishCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GoldenTurtleFishCFG* Fish_GoldenTurtleFishCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GoldenTurtleFishCFG());
	}
	return msSingleton.get();
}

void Fish_GoldenTurtleFishCFG::Release()
{
	msSingleton.reset(nullptr);
}
